Global pcos.d
Global ncos.d
Global psin.d
Global nsin.d
Global RotatedX.d ;<< are used for the RotatePoint Procedure 
Global RotatedY.d ;<<
Global MATHm.d;<< f(x)=mx+b
Global MATHb.d;<<

Global pi.d
pi=3.1415926535

Procedure mb(x1.f,y1.f,x2.f,y2.f)
    MATHm=(y1-y2)/(x1-x2)
    MATHb=y1-(MATHm*x1)
EndProcedure

Procedure cPN(rad.d)
   pcos=Cos(rad*2*pi/360)
   ncos=Cos(-rad*2*pi/360)
   psin=Sin(rad*2*pi/360)
   nsin=Sin(-rad*2*pi/360)
EndProcedure

Procedure RotatePoint(PX.d,PY.d,MX.d,MY.d,Angle.d)
   While Angle>=360
      Angle-360
   Wend 
   While Angle<0
      Angle+360
   Wend   
   cPN(-Angle)
   HX.d=psin*(PY-MY)+pcos*(PX-MX)
   HY.d=pcos*(PY-MY)-psin*(PX-MX)
   RotatedX=HX+MX
   RotatedY=HY+MY
EndProcedure

Procedure.d Min(a.d,b.d)
   If a>b
      ProcedureReturn b
   Else
      ProcedureReturn a
   EndIf
EndProcedure

Procedure.d Max(a.d,b.d)
   If a>b
      ProcedureReturn a
   Else
      ProcedureReturn b
   EndIf
EndProcedure

Procedure.d IntervalDistance(A1.d,B1.d,A2.d,B2.d)
   If A1<A2
      ProcedureReturn (A2-B1)
   Else
      ProcedureReturn (A1-B2)
   EndIf
EndProcedure

Procedure RectsOverlap(minx1.d,miny1.d,maxx1.d,maxy1.d,minx2.d,miny2.d,maxx2.d,maxy2.d)
    If IntervalDistance(minx1,maxx1,minx2,maxx2)<0 And IntervalDistance(miny1,maxy1,miny2,maxy2)<0
       ProcedureReturn 1
    Else
       ProcedureReturn 0
    EndIf
EndProcedure

Procedure sgn(x.d)
   If x>0
      ProcedureReturn 1
   ElseIf x<0
      ProcedureReturn -1
   Else
      ProcedureReturn 0
   EndIf
EndProcedure

Procedure.d Absolut(a.d)
    If a>0
       ProcedureReturn a
    Else
       ProcedureReturn -a
    EndIf
EndProcedure

Procedure.d Cut(x.d,n.l)
   Protected y.d
   y=x
   y*Pow(10,n)
   y=Round(y, #PB_Round_Down)
   y/Pow(10,n)
   ProcedureReturn y
EndProcedure

Procedure.d Arc(mx.d,my.d,px.d,py.d)
   Protected x.d
   Protected y.d
   Protected a.d
   y=Abs(my-py)
   x=Abs(mx-px)
   a=ATan(x/y)
   
   If py>my And px>mx
      a=pi-a
   ElseIf py>=my And px<=mx
      a+pi
   ElseIf py<my And px<mx
      a=2*pi-a
   EndIf     
   ProcedureReturn a
EndProcedure

Procedure InPeriod(n1,n2,k)
   If n1>n2
      n1-k
   EndIf
   If n1+1=n2
      ProcedureReturn 1
   Else
      ProcedureReturn 0
   EndIf
EndProcedure
; IDE Options = PureBasic 4.31 (Windows - x86)
; CursorPosition = 116
; Folding = Ag-
; EnableXP
; Executable = water.exe