Global camx.f
Global camy.f
Global camZoom.f=1
Global screenX.w
Global screenY.w

Procedure initCam(ScreenWidth,ScreenHeight)
   screenX=ScreenWidth
   screenY=ScreenHeight
EndProcedure

Procedure.f CoardinateToScreenX(x.f)
   ProcedureReturn Round((x-camx)*camZoom+screenX/2,#PB_Round_Down)
EndProcedure
Procedure.f CoardinateToScreenY(y.f)
   ProcedureReturn Round((y-camy)*camZoom+screenY/2,#PB_Round_Down)
EndProcedure
Procedure.f ScreenToCoardinateX(x.f)
   ProcedureReturn (x-screenX/2)/camZoom+camx
EndProcedure
Procedure.f ScreenToCoardinateY(y.f)
   ProcedureReturn (y-screenY/2)/camZoom+camy
EndProcedure

Procedure controlCam()
   If MouseWheel()>0 Or KeyboardReleased(#PB_Key_Subtract)
      camZoom*0.9
   ElseIf MouseWheel()<0 Or KeyboardReleased(#PB_Key_Add)
      camZoom/0.9
   EndIf
   
   If MouseButton(2)
      camx-MouseDeltaX()/camZoom
      camY-MouseDeltaY()/camZoom
   EndIf
EndProcedure

Procedure renderConstraint(*c.constraint)
        If *c\parent\id=1
            FrontColor(RGB(0,0,255))
         ElseIf *c\collision>0
            FrontColor(RGB(255,0,0))
         Else
            FrontColor(RGB(255,255,255))
         EndIf
         If minimalrender=0
            x1=CoardinateToScreenX(*c\p1\p\x)
            y1=CoardinateToScreenY(*c\p1\p\y)
            x2=CoardinateToScreenX(*c\p2\p\x)
            y2=CoardinateToScreenY(*c\p2\p\y)
            LineXY(x1,y1,x2,y2)
         ElseIf constraint()\parent\id<>1
            x1=CoardinateToScreenX(*c\p1\p\x)
            y1=CoardinateToScreenY(*c\p1\p\y)
            x2=CoardinateToScreenX(*c\p2\p\x)
            y2=CoardinateToScreenY(*c\p2\p\y)
            LineXY(x1,y1,x2,y2,RGB(255,255,255))
         EndIf
EndProcedure
Procedure renderConstraints()
      ForEach constraint() 
         renderConstraint(constraint())
      Next
EndProcedure
Procedure RenderParticles()
   ForEach particle()
      If particle()\collision>0
         x=CoardinateToScreenX(particle()\p\x-2)
         y=CoardinateToScreenY(particle()\p\y-2)
         Box(x,y,5*camZoom,5*camZoom,RGB(255,0,0))
      Else
         x=CoardinateToScreenX(particle()\p\x)
         y=CoardinateToScreenY(particle()\p\y)
         Circle(x,y,(particle()\r+2)*camZoom,RGB(200,200,255))
         ;DrawText(x,y,Str(particle()\id),RGB(255,255,255),RGB(0,0,0))
      EndIf
   Next
EndProcedure
; IDE Options = PureBasic 4.61 (Windows - x86)
; CursorPosition = 36
; Folding = A5
; EnableXP